;;;-*- Mode: Lisp; Package: COMMON-LISP-USER -*-
;;; Ystok-Widgets - LispWorks CAPI-based GUI framework
;;; Copyright (c) 2003-2013 Dr. Dmitriy Ivanov. All rights reserved.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; System definition

(in-package :cl-user)

#-(and lispworks capi) (error "This code can only run on LispWorks CAPI.")

;(pushnew :ys-product *features*)
;(pushnew :Russian *features*)
;(pushnew :debug *features*)
;(removef *features* :debug) 
;(yl:debug-on :ywidgets) (yl:debug-off :ywidgets)
;
;(load #P"PROJECTS:ylib;ffc;defsys")
;(compile-system 'YSTOK-FFC :load t)
;(load #P"PROJECTS:ylib;defsys")
;(compile-system 'YSTOK-LIBRARY :load t)
;(load #P"PROJECTS:ylib;local-time;defsys")
;(compile-system 'LOCAL-TIME :load t)

(defsystem YWIDGETS (:object-pathname (lw:current-pathname
	#+(not (or Russian German debug))		"bin/"
	#+(and (not Russian) (not German) debug)	"bin/debug/"
	#+(and Russian (not debug))			"bin/ru/"
	#+(and Russian debug)				"bin/debug/ru/"
	#+(and German (not debug))			"bin/de/"
	#+(and German debug)				"bin/debug/de/"))
 :members
 ((YSTOK-FFC :type :system)
  (YSTOK-LIBRARY :type :system)
  ;; LW BUG? The :features declaration for a subsystem seems to be ignored
  ;;	     while interpreting the rules!
  #+local-time (LOCAL-TIME :type :system)
  ("capi50-compat"	:features (and :lispworks4 (not :win32)))
  "ywi-package"
  ("lang/ru"		:features :Russian)
  ("lang/de"		:features :German)
  "ywi-basics"
  "capi-hacks"
  ("capi60-compat"	:features (or :lispworks4 :lispworks5))
  "icons"
  "ywi-text"
  "confirmers"
  "editable-pinboard"
  "toolbars"
  "progress-dialog"
  ("lang/product-ru"	:features (and :ys-product :Russian))
  ("accelerators"	:features :ys-product)
  ("data-pane"		:features :ys-product)
  ("lockable-pane"	:features :ys-product)
  ("popup-choice"	:features :ys-product)
  ("widgets"		:features :ys-product)
  ("layouts"		:features :ys-product)
  ("slave-interfaces"	:features :ys-product)
  ("menus"		:features :ys-product)
  ("settings-dialog"	:features :ys-product)
  ("file-interface"	:features :ys-product)
  ("editor-interface"	:features :ys-product)	;(and :yw-editor)
  ("history-interface"	:features :ys-product)	;(and :yw-history)
  ("log-interface"	:features :ys-product)	;(and :yw-log)
  ("wizard-interface"	:features :ys-product)
  ("lang/local-time-ru"	:features (and :ys-product :local-time :Russian))
  ("ywi-local-time"	:features (and :ys-product :local-time))
  ("ywi-time-interval"	:features (and :ys-product :local-time))
 )
 :rules
 ((:in-order-to :compile ("ywi-package")
   (:caused-by (:compile YSTOK-FFC YSTOK-LIBRARY))
   (:requires (:load YSTOK-FFC YSTOK-LIBRARY #+local-time LOCAL-TIME)))
  (:in-order-to :load ("ywi-package")
   (:requires (:load YSTOK-FFC YSTOK-LIBRARY #+local-time LOCAL-TIME)))

  (:in-order-to :compile ("ru" "de" "icons" "product-ru")
   (:requires (:load "ywi-package")))
  (:in-order-to :load ("ru" "de" "icons" "product-ru")
   (:requires (:load "ywi-package")))

  (:in-order-to :compile "ywi-basics"
   (:caused-by (:compile "ywi-package" "ru" "de"))
   (:requires (:load "ywi-package" "ru" "de")))
  (:in-order-to :load "ywi-basics"
   (:requires (:load "ywi-package" "ru" "de")))

  (:in-order-to :compile ("capi-hacks" "ywi-text")
   (:requires (:load "ywi-basics")))
  (:in-order-to :load ("capi-hacks" "ywi-text")
   (:requires (:load "ywi-basics")))

  (:in-order-to :compile "capi60-compat" (:requires (:load "capi-hacks")))
  (:in-order-to :load "capi60-compat" (:requires (:load "capi-hacks")))

  (:in-order-to :compile ("confirmers" "data-pane" "lockable-pane" "toolbars"
                          "progress-dialog")
   (:caused-by (:compile "ywi-basics" "icons"))
   (:requires (:load "ywi-basics" "capi60-compat" "icons" "ywi-text")))
  (:in-order-to :load ("confirmers" "data-pane" "lockable-pane" "toolbars"
                       "progress-dialog")
   (:caused-by (:load "ywi-package" "ru" "de"))
   (:requires (:load "ywi-basics" "capi60-compat" "icons" "ywi-text")))

  (:in-order-to :compile "editable-pinboard"
   (:caused-by (:compile "capi-hacks"))
   (:requires (:load "capi-hacks" "confirmers")))
  (:in-order-to :load "editable-pinboard"
   (:requires (:load "capi-hacks" "confirmers")))

  (:in-order-to :compile "accelerators"
   (:caused-by (:compile "ywi-package"))
   (:requires (:load "capi-hacks" "toolbars")))
  (:in-order-to :load "accelerators"
   (:caused-by (:load "ywi-package"))
   (:requires (:load "capi-hacks" "toolbars")))

  (:in-order-to :compile ("data-pane" "popup-choice")
   (:caused-by (:compile "editable-pinboard"))
   (:requires (:load "confirmers" "editable-pinboard")))
  (:in-order-to :load ("data-pane" "popup-choice")
   (:caused-by (:load "ywi-package"))
   (:requires (:load "confirmers" "editable-pinboard")))

  (:in-order-to :compile "lockable-pane"
   (:caused-by (:compile "data-pane" "product-ru"))
   (:requires (:load "data-pane" "product-ru")))
  (:in-order-to :load "lockable-pane"
   (:requires (:load "data-pane" "product-ru")))

  (:in-order-to :compile "widgets"
   (:caused-by (:compile "icons" "data-pane" "product-ru"))
   (:requires (:load "icons" "data-pane" "product-ru")))
  (:in-order-to :load "widgets"
   (:caused-by (:load "ywi-package"))
   (:requires (:load "icons" "data-pane" "product-ru")))

  (:in-order-to :compile "layouts"
   (:caused-by (:compile "ywi-package" "product-ru"))
   (:requires (:load "capi-hacks" "toolbars" "accelerators" "product-ru")))
  (:in-order-to :load "layouts"
   (:caused-by (:load "ywi-package"))
   (:requires (:load "capi-hacks" "toolbars" "accelerators" "product-ru")))

  (:in-order-to :compile "slave-interfaces"
   (:caused-by (:compile "ywi-package" "product-ru"))
   (:requires (:load "capi-hacks" "toolbars" "popup-choice" "accelerators" "product-ru")))
  (:in-order-to :load ("slave-interfaces" "layouts")
   (:caused-by (:load "ywi-package"))
   (:requires (:load "capi-hacks" "toolbars" "popup-choice" "accelerators" "product-ru")))

  (:in-order-to :compile "menus"
   (:caused-by (:compile "ywi-package" "product-ru"))
   (:requires (:load "capi60-compat" "lockable-pane" "slave-interfaces" "product-ru")))
  (:in-order-to :load "menus"
   (:caused-by (:load "ywi-package"))
   (:requires (:load "capi60-compat" "lockable-pane" "slave-interfaces" "layouts"
                     "product-ru")))

  (:in-order-to :compile "settings-dialog"
   (:caused-by (:compile "data-pane" "product-ru"))
   (:requires (:load "data-pane" "layouts" "product-ru")))
  (:in-order-to :load "settings-dialog"
   (:caused-by (:load "ywi-package"))
   (:requires (:load "data-pane" "layouts" "product-ru")))

  (:in-order-to :compile ("file-interface" "log-interface")
   (:caused-by (:compile "ywi-package" "ru" "de" "product-ru"))
   (:requires (:load "confirmers" "settings-dialog" "widgets"
                     "layouts" "accelerators" "menus")))
  (:in-order-to :load ("file-interface" "log-interface")
   (:caused-by (:load "ywi-package"))
   (:requires (:load "confirmers" "settings-dialog" "widgets"
                     "layouts" "accelerators" "menus" "product-ru")))

  (:in-order-to :compile "editor-interface"
   (:caused-by (:compile "ywi-package" "product-ru"))
   (:requires (:load "file-interface")))
  (:in-order-to :load "editor-interface"
   (:caused-by (:load "ywi-package"))
   (:requires (:load "file-interface")))

  (:in-order-to :compile "history-interface"
   (:caused-by (:compile "capi-hacks" "product-ru"))
   (:requires (:load "capi-hacks" "confirmers" "product-ru")))
  (:in-order-to :load "history-interface"
   (:requires (:load "capi-hacks" "confirmers" "product-ru")))

  (:in-order-to :compile "wizard-interface"
   (:caused-by (:compile "ru" "product-ru"))
   (:requires (:load "slave-interfaces" "progress-dialog")))
  (:in-order-to :load "wizard-interface"
   (:requires (:load "slave-interfaces" "progress-dialog")))

  (:in-order-to :compile "ywi-local-time"
   (:caused-by (:compile #+local-time LOCAL-TIME
                         "ywi-package" "popup-choice" "local-time-ru"))
   (:requires (:load #+local-time LOCAL-TIME "popup-choice" "local-time-ru")))
  (:in-order-to :load "ywi-local-time"
   (:caused-by (:load "ywi-package"))
   (:requires (:load #+local-time LOCAL-TIME "popup-choice" "local-time-ru")))

  (:in-order-to :compile "ywi-time-interval"
   (:requires (:load #+local-time LOCAL-TIME "ywi-local-time" "local-time-ru")))
  (:in-order-to :load "ywi-time-interval"
   (:caused-by (:load "ywi-package"))
   (:requires (:load "ywi-local-time" "local-time-ru")))
))

#+ys-product
(ys:defmodule :ywidgets (1 0 :abbrev "wid") :depends-on (:ylib #+local-time :local-time))

;(compile-system 'YWIDGETS :load t)
