;;;-*- Mode: Lisp; -*-
;;; YstokWidgets - LispWorks CAPI-based GUI framework
;;; Copyright (c) 2003-2013 Dr. Dmitry Ivanov. All rights reserved.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ASDF or ASDlite system definition

(in-package :cl-user)

#-(and lispworks capi) 
(error "This code can only run on LispWorks CAPI.")

(asdf:defsystem ywidgets
  :author "Dmitry Ivanov"
  :maintainer "Dmitry Ivanov"
  :licence "Lessor Lisp General Public License, see file COPYING.txt"
  :description "CAPI-based GUI framework"
  #+asdlite #+asdlite
  :output-pathname (asd:current-location "bin/")

  :depends-on (ystok-library
               #+local-time ystok-local-time)
  :components
  (#+(and lispworks4 (not win32))
   (:file "capi50-compat")
   (:file "ywi-package")
   (:module "lang" :depends-on ("ywi-package")
    :components
    (#+Russian (:file "ru")
     #+German  (:file "de")
     #+(and ys-product Russian) (:file "product-ru")
     #+(and ys-product local-time Russian) (:file "local-time-ru")))
   (:file "ywi-basics"		:depends-on ("lang"))
   (:file "capi-hacks"		:depends-on ("ywi-basics"))
   #+(or lispworks4 lispworks5)
   (:file "capi60-compat"	:depends-on ("capi-hacks"))
   (:file "icons"		:depends-on ("ywi-package"))
   (:file "ywi-text"		:depends-on ("ywi-basics"))
   (:file "confirmers" 		:depends-on ("ywi-basics" "icons" "ywi-text"
					     #+(or lispworks4 lispworks5) "capi60-compat"))
   (:file "editable-pinboard"	:depends-on ("capi-hacks"))
   (:file "toolbars"		:depends-on ("ywi-basics"
					     #+(or lispworks4 lispworks5) "capi60-compat"))
   (:file "progress-dialog"	:depends-on ("toolbars"))

   #+ys-product (:file "data-pane" :depends-on ("editable-pinboard"
					     #+(or lispworks4 lispworks5) "capi60-compat"))
   #+ys-product (:file "lockable-pane"	:depends-on ("data-pane"))
   #+ys-product (:file "popup-choice"	:depends-on ("confirmers"
                                                     "editable-pinboard" "data-pane"))
   #+ys-product (:file "slave-interfaces" :depends-on ("capi-hacks" "toolbars"
                                                       "popup-choice"))
   #+ys-product (:file "widgets"	:depends-on ("icons" "data-pane"))
   #+ys-product (:file "layouts"	:depends-on ("capi-basics" "toolbars"))
   #+ys-product (:file "accelerators"	:depends-on ("capi-basics" "toolbars"))
   #+ys-product (:file "menus"		:depends-on ("lockable-pane" "slave-interfaces"))
   #+ys-product (:file "settings-dialog" :depends-on ("data-pane" "history-interface"))
   #+ys-product (:file "file-interface"	:depends-on ("settings-dialog" "widgets"
                                                     "layouts" "accelerators" "menus"))
   #+ys-product (:file "editor-interface" :depends-on ("file-interface"))
   #+ys-product (:file "history-interface" :depends-on ("capi-hacks" "confirmers"))
   #+ys-product (:file "log-interface" :depends-on ("confirmers" "settings-dialog"
                                                    "widgets" "layouts" "menus"))
   #+ys-product (:file "wizard-interface" :depends-on ("progress-dialog"
                                                       "slave-interfaces"))
   #+(and ys-product local-time)
                (:file "ywi-local-time" :depends-on ("popup-choice"))
   #+(and ys-product local-time)
                (:file "ywi-time-interval" :depends-on ("popup-choice"))))

;(asdf:operate 'asdf:load-op 'ywidgets)
